/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 daemon.h v 0.0.0 1999/11/24
 		  v 1.6.0 2000/03/25	- Add COMPRESSION type
		  v 1.6.1 2000/03/30	- Set the TCPWINSIZE for OSF1 to 128000
		  						- Add STARCHILDTO time out for the child
								  when waiting for the HUP signal (set up
								  for machines where the HUP signal was
								  sent by the father before the child waits
								  on the select
		  v 1.8.0 2000/04/14	- Add NBITSINKEY for the Crypto
		  v 1.8.1 2000/04/17	- Increase CONTROLSOCKTO because 
								  the time to get the RSA key is not
								  neglectable
		  v 1.8.7 2000/05/25	- Rewrite header 
 
*****************************************************************************/

/* RETRSTARTTO :
**		Define the time out to wait a retreive start message on the control socket.
**		Expressed in second, usual value 100.
*/
#define RETRSTARTTO 100

/* STARTCHILDTO :
**		Define the time a child has to wait before starting
**		Expressed in second, usual value 20.
*/
#define STARTCHILDTO 20

