/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 sendfile.c v 0.0 2000/01/11
 
*****************************************************************************/
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <structures.h>
#include <daemon.h>
#include <zlib/zlib.h>

#define ACKTO 100

main(argc, argv, envp)
	int argc;
	char **argv;
	char **envp;
{
	int		fd ;
	int		i ;
	int		nbdatawait ;
	int		ns ;
	
	off64_t 	nbperchild ;
	off64_t 	nbtosend ;
	off64_t 	nbread ;
	off64_t 	nbsent ;
	off64_t 	numberread ;
	off64_t 	startpoint ;
	
	char	title[2048] ;
	char	buffer[256000] ;
	char	buffercomp[300000] ;
	uLong	comprlen ;
	uLong	buflen ;
	
	char	filename[500] ;
	
	static char	answer_buffer[MAXMESSLEN] ;
	struct	message *msg ;
	int		retcode ;
	int		msglen ;

	struct timeval  tstart, tend ,tdiff;
	float	s, bs, a, nb;
	
	strcpy(filename,"/scratch/IN2P3.WV0017.SL.1.V_1") ;
	
	if ( ( fd = open(filename,O_RDONLY|O_LARGEFILE) ) < 0 ) {
		printf("Child %06d : Error opening file %s\n",getpid(),filename) ;
		_exit(1) ;
	}
	if ( lseek64(fd,0,SEEK_SET) < 0 ) {
		printf("Child %06d : Error seeking file %s\n",getpid(),filename) ;
		_exit(1) ;
	}
	nbtosend = 3650076640 ;
	nbread = 0 ;
	numberread = 0 ;
	a = 0.0 ;
	nb = 0.0 ;
	msglen = 0 ;
	while ( nbread < nbtosend ) {
		if ( (numberread = read ( fd, buffer, (sizeof(buffer) <= nbtosend - nbread) ? sizeof(buffer) : nbtosend-nbread) ) > 0 ) {
			buflen = numberread ;
			comprlen = 256000 ;
			retcode = compress((Bytef*)buffercomp,&comprlen,(Bytef*)buffer,buflen) ;
			if  ( retcode < 0 ) printf("compress retcode  %d\n",retcode) ;
			printf("comprlen %d\n",comprlen) ;
			s = numberread ;
			bs = comprlen ;
			a = a+(s/bs) ;
			nb ++ ;
			msglen ++ ;
			nbread = nbread+numberread ;
		} else {
			printf("Child %06d : Error reading : %s",getpid(),strerror(errno)) ;
			_exit(1) ;
		}
		if ( msglen == 100 ) {
			msglen = 0 ;
			printf("Ratio moyen %.3g\n",a/nb) ;
		}
	}
	printf("Ratio moyen %.3g\n",a/nb) ;
}
