/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
 
*****************************************************************************/
#include <dirent.h>
#include <errno.h>
#include <fnmatch.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/stat.h>

main() {
	int	i,retcode,k;
	char	pattern[100] ;
	DIR     *curdir ;
	char	**tt ;
	char	*toto ;
    struct  dirent *dp ;
    char    *pointer, *pointer2;
    int     lastslash ;
    char    *dirpath ;
    int     lentoalloc,maxlen ;
    char    *sendbuffer ;
    char    *filename ;
	struct stat statbuf ;
    int     islink ;
/*	
    strcpy(pattern,"/afs/in2p3.fr/home/f/farrache/babar/version-2.0.0/bbftpd/obj.SunOS.5.6/*") ;
*/
    strcpy(pattern,"/afs/in2p3.fr/home/f/farrache/babar/version-2.0.0/bbftpd/obj.SunOS.5.6/*") ;
	dirpath = (char *) malloc ( strlen(pattern) + 1 + 3 ) ; 
    pointer = pattern ;
    lastslash = strlen(pointer) - 1 ;
    while ( lastslash >= 0 && pointer[lastslash] != '/') lastslash-- ;
    printf("lestslash = %d \n",lastslash) ;
    if ( lastslash == -1 ) {
        /*
        ** No slash in the path, so this is a pattern and we have
        ** to opendir .
        */
        if ( (curdir = opendir(".")) == NULL ) {
		    printf("opendir . failed : %s \n",strerror(errno)) ;
            return 0 ;
        }
        strcpy(dirpath,"./") ;
    } else if ( lastslash == 0 ) {
        /*
        ** A slash in first position so we are going to open the
        ** / directory
        */
        if ( (curdir = opendir("/")) == NULL ) {
		    printf("opendir / failed : %s \n",strerror(errno)) ;
            return 0 ;
        }
        strcpy(dirpath,"/") ;
        pointer++ ;
    } else if ( lastslash == strlen(pointer) - 1 ) {
        /*
        ** The filename end with a slash ..... error
        */
		printf("Pattern %s ends with a /\n",pattern) ;
        return 0 ;
    } else {
        pointer[lastslash] = '\0';
        if ( (curdir = opendir(pointer)) == NULL ) {
		    printf("opendir %s failed : %s ",pointer,strerror(errno)) ;
            return 0 ;
        }
        strcpy(dirpath,pointer) ;
        dirpath[lastslash] = '/';
        dirpath[lastslash+1] = '\0';
        for ( i = 0 ; i <= lastslash ; i++ ) pointer++ ;
    }
    printf("pointer = %s \n",pointer) ;
    printf("directory  = %s \n",dirpath) ;
    lentoalloc = 0 ;
    maxlen = 0 ;
    while ( (dp = readdir(curdir) ) != NULL) {
        if ( fnmatch(pointer, dp->d_name,0) == 0){
            printf("filename = %s \n",dp->d_name) ;
            lentoalloc = lentoalloc + strlen(dp->d_name) + 1 + 3 ;
            if ( maxlen <  strlen(dp->d_name) ) maxlen = strlen(dp->d_name) ;
        }
    }
    rewinddir(curdir) ;
    sendbuffer = (char *) malloc (lentoalloc) ;
    pointer2 = sendbuffer ;
    filename   = (char *) malloc (strlen(dirpath)+maxlen+1) ;
    while ( (dp = readdir(curdir) ) != NULL) {
        if ( fnmatch(pointer, dp->d_name,0) == 0){
            sprintf(filename,"%s%s",dirpath,dp->d_name) ;
            printf("filename = %s \n",filename) ;
            for ( i = 0 ; i < strlen(dp->d_name) ; i++ ) {
                *pointer2++ = dp->d_name[i]  ;
            }
            *pointer2++ = '\0' ;
            islink = 0 ;
	        if ( lstat(filename,&statbuf) < 0 ) {
                printf("lstat error\n") ;
                exit(0) ;
            }
            if ( (statbuf.st_mode & S_IFLNK) == S_IFLNK) {
                *pointer2++ = 'l' ;
                islink = 1 ;
           } else {
                *pointer2++ = ' ' ;
            }
	        if ( stat(filename,&statbuf) < 0 ) {
                if ( islink == 1 ) {
                    *pointer2++ = 'u' ;
                } else {
                    printf("stat error : %s\n",strerror(errno)) ;
                    exit(0) ;
                }
            } else {
		        if ( (statbuf.st_mode & S_IFDIR) == S_IFDIR) {
                    *pointer2++ = 'd' ;
		        } else {
                    *pointer2++ = 'f' ;
                }
            }
            *pointer2++ = '\0' ;
        }
    }
    closedir(curdir) ;
    for ( i = 0 ; i < lentoalloc ; i++ ) { 
        if ( sendbuffer[i] == '\0' ) {
            putchar('\n') ;
        } else {
            putchar(sendbuffer[i]) ;
        }
    }
        
}

 
