/****************************************************************************

 Copyright (c) 1999,2000,2001 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 
 This header contains all parameters that are user configurable
 
 config.h   v 1.8.7 2000/05/23	- Header creation
            v 1.9.3 2000/10/12	- Add FIXEDDATAPORT for d0 use
            v 2.0.0 2000/12/13  - Supress DAEMONMODE(set as option
                                  on the command line)
                                - Supress FIXEDDATAPORT (set as option
                                  on the command line)

*****************************************************************************/

/* CONTROLPORT :
**		That is the port the server is listening on, the default port
**		for that application is 4021 which allow the daemon to be run by
**		user. This port is also used by the client in order to connect to
**		the server
**		Default 5021
**		Starting with version 1.9.3 in case of DAEMONMODE equal to 2
**		this can be overriden on the command line 
**		Used by the server and the client
*/
#define CONTROLPORT 5021

/* AFS :
**		Define if the authentication is using AFS. Uncomment those lines
**		if you want to use AFS
**		Used by the server
*/
/*
#define AFS 1
*/
/* RFIO :
**		Define if you want to use RFIO. Uncomment those lines if you do 
**		want use RFIO
**		Used by the server and the client
*/
/*
#define RFIO 1
*/
